// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"
	io "io"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// TerraformProviderPlatform is an autogenerated mock type for the TerraformProviderPlatform type
type TerraformProviderPlatform struct {
	mock.Mock
}

// CreateProviderPlatform provides a mock function with given fields: ctx, input
func (_m *TerraformProviderPlatform) CreateProviderPlatform(ctx context.Context, input *types.CreateTerraformProviderPlatformInput) (*types.TerraformProviderPlatform, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformProviderPlatform
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTerraformProviderPlatformInput) (*types.TerraformProviderPlatform, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTerraformProviderPlatformInput) *types.TerraformProviderPlatform); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformProviderPlatform)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateTerraformProviderPlatformInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProviderPlatform provides a mock function with given fields: ctx, input
func (_m *TerraformProviderPlatform) GetProviderPlatform(ctx context.Context, input *types.GetTerraformProviderPlatformInput) (*types.TerraformProviderPlatform, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformProviderPlatform
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformProviderPlatformInput) (*types.TerraformProviderPlatform, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformProviderPlatformInput) *types.TerraformProviderPlatform); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformProviderPlatform)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetTerraformProviderPlatformInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UploadProviderPlatformBinary provides a mock function with given fields: ctx, providerPlatformID, reader
func (_m *TerraformProviderPlatform) UploadProviderPlatformBinary(ctx context.Context, providerPlatformID string, reader io.Reader) error {
	ret := _m.Called(ctx, providerPlatformID, reader)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, io.Reader) error); ok {
		r0 = rf(ctx, providerPlatformID, reader)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

type mockConstructorTestingTNewTerraformProviderPlatform interface {
	mock.TestingT
	Cleanup(func())
}

// NewTerraformProviderPlatform creates a new instance of TerraformProviderPlatform. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewTerraformProviderPlatform(t mockConstructorTestingTNewTerraformProviderPlatform) *TerraformProviderPlatform {
	mock := &TerraformProviderPlatform{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
